/****************************************************
**
** PICProgrammerHardware.CPP
**
****************************************************/

//#include "PICProgrammerHardware.H"
#include "PICPH.H"
//#include "PICProgrammerTiming.H"
#include "PICPT.H"

#include <stdio.h>
#include <conio.h>

/*
**
*/
PICProgrammerHardwareClass::PICProgrammerHardwareClass( void )
{
//	Set_State( VPP_OFF | VDD_OFF | CLOCK_OFF | DATA_OFF );
}

/*
**
*/
PICProgrammerHardwareClass::~PICProgrammerHardwareClass( void )
{
//	Set_State( VPP_OFF | VDD_OFF | CLOCK_OFF | DATA_OFF );
}


/*
**
*/
void	PICProgrammerHardwareClass::Program( void )
{
	Set_State( VPP_OFF | VDD_ON | CLOCK_OFF | DATA_OFF );
	Delay_Ms( POWER_UP_DELAY );
	Set_State( VPP_ON );
	Delay_Ms( PROGRAMMING_START_DELAY );
}


/*
**
*/
void	PICProgrammerHardwareClass::Off( void )
{
	Set_State( VPP_OFF | VDD_OFF | CLOCK_OFF | DATA_OFF );
}


void delay() { int j = 1;  for (int i = 0; i < 100; i++) j *=3; }

/*
**
*/
void	PICProgrammerHardwareClass::Send_Data_Bit( int bit )
{
	Set_State( CLOCK_ON | ( ( bit ) ? DATA_ON : DATA_OFF ) );
	delay();
//	Delay_Ms( CLOCK_DELAY );
	Set_State( CLOCK_OFF );
	delay();
//	Delay_Ms( CLOCK_DELAY );
	Set_State( DATA_ON );
}


/*
**
*/
int	PICProgrammerHardwareClass::Get_Data_Bit( void )
{
	Set_State( CLOCK_ON );
	delay();
//	Delay_Ms( CLOCK_DELAY );
	Set_State( CLOCK_OFF | DATA_ON );
	delay();
//	Delay_Ms( CLOCK_DELAY );
	return Get_Input() ? 1 : 0;
}


/*
**
*/
void PICProgrammerHardwareClass::Debug( void )
{
	Set_State( VDD_OFF | VPP_OFF | CLOCK_OFF | DATA_OFF );
	printf( "VDD_OFF | VPP_OFF | CLOCK_OFF | DATA_OFF\n" ); 
	getch();
	Set_State( VDD_ON );
	printf( "VDD_ON\n" );
	getch();
	Set_State( VDD_OFF | VPP_ON );
	printf( "VPP_ON\n" );
	getch();
	Set_State( VPP_OFF | CLOCK_ON );
	printf( "CLOCK_ON\n" );
	getch();
	Set_State( CLOCK_OFF | DATA_ON );
	printf( "DATA_ON\n" );
	getch();
	Set_State( VDD_OFF | VPP_OFF | CLOCK_OFF | DATA_OFF );
}
